'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _response = require('./response');

var _response2 = _interopRequireDefault(_response);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const request = require('request');
class JustAPIRequest {
    constructor(options, test) {
        this.options = options;
        this.test = test;
    }

    async send() {
        const self = this;
        self.options.time = true;

        try {
            let response = await new Promise(function (resolve, reject) {
                request(self.options, function (err, response, body) {
                    let log = {};

                    log.request = {
                        uri: this.uri.href,
                        method: this.method,
                        headers: _extends({}, this.headers)
                    };

                    if (this.body) {
                        log.request.body = this.body.toString('utf8');
                    } else if (this.formData) {
                        log.request.formRequest = true;
                        log.request.body = _extends({}, this.formData);
                    }

                    if (err !== null) {
                        log.error = err;
                        self.test.suite.requests.push(log);
                        return reject(err);
                    }

                    log.response = {
                        headers: _extends({}, response.headers),
                        statusCode: response.statusCode,
                        body: body,
                        timings: _extends({}, response.timingPhases)
                    };

                    self.test.suite.requests.push(log);

                    let justAPIResponse = new _response2.default(this, err, response, body);
                    return resolve(justAPIResponse);
                });
            });

            return response;
        } catch (error) {
            throw error;
        }
    }

}
exports.default = JustAPIRequest;
module.exports = exports['default'];